import G6 from '@antv/g6'

export default (g6: typeof G6) => {
  g6.registerBehavior('canvas-event', {
    getDefaultCfg() {
      return {}
    },
    shouldBegin(e) {
      return true
    },
    getEvents() {
      return {
        'canvas:mousemove': 'onCanvasMouseMove',
        'canvas:mousedown': 'onCanvasMouseDown',
        'canvas:mouseup': 'onCanvasMouseUp',
        'canvas:dragend': 'onCanvasDragEnd'
      }
    },
    onCanvasMouseMove(e) {
      e.target.get('el').style.cursor = 'grab'
    },
    onCanvasMouseDown(e) {
      e.target.get('el').style.cursor = 'grabbing'
    },
    onCanvasMouseUp(e) {
      e.target.get('el').style.cursor = 'grab'
    },
    onCanvasDragEnd(e) {
      e.target.get('el').style.cursor = 'grab'
      this.graph.emit('on-canvas-dragend', e)
    }
  })
}
